/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model;

import model.impl.IHElementDeltaImpl;

/**
 * TODO JavaDoc
 */
public interface IHElementDeltaMirror
{
    int ADDED = 1;
    int REMOVED = 2;
    int CHANGED = 3;

    long F_CONTENT = 0x1;
    long F_CHILDREN = 0x2;

    default IHElementDelta hDelta()
    {
        return (IHElementDelta)this;
    }

    default IHElement getElement()
    {
        return ((IHElementDeltaImpl)hDelta()).hElement();
    }

    default int getKind()
    {
        return ((IHElementDeltaImpl)hDelta()).hKind();
    }

    default long getFlags()
    {
        return ((IHElementDeltaImpl)hDelta()).hFlags();
    }

    default IHElementDelta[] getAffectedChildren()
    {
        return ((IHElementDeltaImpl)hDelta()).hAffectedChildren();
    }
}
